<?php

namespace FiloBlu\LogView\Model\ResourceModel\Reports;

use Magento\Framework\Data\Collection as DataCollection;

class Collection extends DataCollection {

    protected $directory_list;

    public function __construct(DataCollection\EntityFactoryInterface $entityFactory, \Magento\Framework\App\Filesystem\DirectoryList $directory_list) {

        $this->directory_list = $directory_list;

        $this->populateGrid();

        parent::__construct($entityFactory);
    }

    protected function populateGrid() {

        foreach (glob($this->directory_list->getPath('var') . DIRECTORY_SEPARATOR . "report" . DIRECTORY_SEPARATOR . "*") as $file) {
            $obj = new \Magento\Framework\DataObject();
            $this->addItem(
                    $obj
                            ->setFilename(basename($file))
                            ->setPath($file)
                            ->setFilesize($this->human_filesize(filesize($file)))
            );
        }
    }

    private function human_filesize($bytes, $decimals = 2) {
        $size = array('B', 'kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
        $factor = floor((strlen($bytes) - 1) / 3);
        return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) . @$size[$factor];
    }

    public function addFieldToFilter($field, $condition) {
        
    }

}
